import { ReduxActionFunc } from '../action/action';
export interface IReduxReducerAction<P = any> {
    payload: P;
}
export declare type ReduxReducerFunc<S, P> = (state: S, action?: IReduxReducerAction<P>) => S;
export declare type ReduxReducerDecorator<S, P> = (target: object, propertyKey: string | symbol, descriptor: TypedPropertyDescriptor<ReduxReducerFunc<S, P>>) => TypedPropertyDescriptor<ReduxReducerFunc<S, P>>;
export declare type ReduxReducerActionType<P> = ReduxActionFunc<Promise<P>> | ReduxActionFunc<P> | string;
export declare type ReduxReducerActionTypeArray<P> = ReduxReducerActionType<P> | Array<ReduxReducerActionType<P>>;
export declare function ReduxReducer<S = any, P = any>(typeArray: ReduxReducerActionTypeArray<P>): ReduxReducerDecorator<S, P>;
